%define section   free
%define base_name commons-javaflow
%define jakarta_version 0.0
%define cvs_date 20051002

Name:           jakarta-%{base_name}
Version:        %{jakarta_version}
Release:        0.%{cvs_date}.1jpp
Epoch:          0
Summary:        Commons JavaFlow
License:        Apache License 2.0
Url:            http://jakarta.apache.org/commons/sandbox/javaflow/
Group:          Development/Libraries/Java
Vendor:         JPackage Project
Distribution:	JPackage
SOURCE0:	%{base_name}-%{cvs_date}-src.tar.gz
#svn export http://svn.apache.org/repos/asf/jakarta/commons/sandbox/javaflow/trunk/

Source1:        pom-maven2jpp-depcat.xsl
Source2:        pom-maven2jpp-newdepmap.xsl
Source3:        pom-maven2jpp-mapdeps.xsl
Source4:        %{base_name}-%{version}-jpp-depmap.xml
Source5:        commons-build.tar.gz
Patch0:         commons-javaflow-0.0-LocalVariables.patch
Patch1:         commons-javaflow-0.0-OperandStack.patch

BuildRequires:  ant >= 0:1.6, jpackage-utils >= 0:1.6
BuildRequires:	junit, maven, saxon, saxon-scripts
BuildRequires:	asm2 >= 0:2.1
BuildRequires:	bcel
BuildRequires:	jakarta-commons-io >= 0:1.1
BuildRequires:	jakarta-commons-jci
BuildRequires:	jakarta-commons-logging
BuildRequires:	xstream

Requires:	asm2 >= 0:2.1
Requires:	bcel
Requires:	jakarta-commons-io >= 0:1.1
Requires:	jakarta-commons-jci
Requires:	jakarta-commons-logging
Requires:	xstream
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-buildroot

%description
Sometimes it is usefull if we can capture the state of the application, 
its stack of function calls, which includes local variables, the global 
variables and the program counter, and save them into an object. If 
this object would give us the ability to restart the processing from 
the point stored in it. 
A continuation is exactly the type of object that we need. Think of a 
continuation as an object that, for a given point in your program, 
contains a snapshot of the stack trace, including all the local 
variables, and the program counter. You can not only store these 
things in the continuation object, but also restore the execution 
of the program from a continuation object. This means that the stack 
trace and the program counter of the running program become the ones 
stored in a continuation. 
Continuations are powerful concepts from the world of functional 
languages, like Scheme, but they are becoming popular in other 
languages as well. 


%package javadoc
Summary:	Javadoc for %{name}
Group:		Development/Documentation

%description javadoc
%{summary}.

%prep
rm -rf $RPM_BUILD_ROOT
%setup -q -n %{base_name}-%{cvs_date}-src
#find . -name "*.jar" -exec rm -f {} \;
for j in $(find . -name "*.jar"); do
	mv $j $j.no
done
gzip -dc %{SOURCE5} | tar xf -

%patch0 -b .sav
%patch1 -b .sav

export DEPCAT=$(pwd)/%{base_name}-%{version}-depcat.new.xml
echo '<?xml version="1.0" standalone="yes"?>' > $DEPCAT
echo '<depset>' >> $DEPCAT
for p in $(find . -name project.xml); do
    pushd $(dirname $p)
    /usr/bin/saxon project.xml %{SOURCE1} >> $DEPCAT
    popd
done
echo >> $DEPCAT
echo '</depset>' >> $DEPCAT
/usr/bin/saxon $DEPCAT %{SOURCE2} > %{base_name}-%{version}-depmap.new.xml


%build
for p in $(find . -name project.xml); do
    pushd $(dirname $p)
    cp project.xml project.xml.orig
    /usr/bin/saxon -o project.xml project.xml.orig %{SOURCE3} map=%{SOURCE4}
    popd
done

for p in $(find . -name project.properties); do
    echo >> $p
    echo maven.repo.remote=file:/usr/share/maven-1.0/repository >> $p
    echo maven.home.local=$(pwd)/.maven >> $p
done

mkdir -p .maven/repository/maven/jars
build-jar-repository .maven/repository/maven/jars \
maven-jelly-tags \

mkdir -p .maven/repository/JPP/jars
build-jar-repository -s -p .maven/repository/JPP/jars \
ant \
asm2/asm2 \
asm2/asm2-analysis \
asm2/asm2-commons \
asm2/asm2-tree \
asm2/asm2-util \
bcel \
commons-io \
commons-jci \
commons-logging \
commons-logging-api \
junit \
xstream \


maven  \
	-Dmaven.javadoc.source=1.4 \
	-Dmaven.home.local=$(pwd)/.maven \
	-Dmaven.jar.override=off \
	jar javadoc 


%install
# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}
install -m 644 target/commons-javaflow-trunk.jar \
           $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar

(cd $RPM_BUILD_ROOT%{_javadir} && for jar in jakarta-*; do \
ln -sf ${jar} ${jar/jakarta-/}; done)
(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}*; do \
ln -sf ${jar} ${jar/-%{version}/}; done)

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr target/docs/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink

## manual
install -d -m 755 $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp -p LICENSE.txt $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}

%clean
rm -rf $RPM_BUILD_ROOT

%post javadoc
ln -sf %{name}-%{version} %{_javadocdir}/%{name}
 
%postun javadoc
if [ "$1" = "0" ]; then
  rm -f %{_javadocdir}/%{name}
fi

%files
%defattr(0644,root,root,0755)
%doc %{_docdir}/%{name}-%{version}/LICENSE.txt
%{_javadir}/*

%files javadoc
%defattr(0644,root,root,0755)
%doc %{_javadocdir}/%{name}-%{version}
%ghost %{_javadocdir}/%{name}

%changelog
* Wed Oct 18 2005 Ralph Apel <r.apel@r-apel.de> 0:0.0-0.20051002.1jpp
- First release
